import type { ToolbarsPreset } from '../../../modules/toolbars/types';
import type { MarkdownEditorViewProps } from '../../MarkdownEditorView';
import type { MarkdownEditorPreset } from '../../types';
import type { MToolbarData, WToolbarData } from '../types';
export declare const createToolbarConfig: <T extends WToolbarData | MToolbarData>(editorType: 'wysiwyg' | 'markup', toolbarPreset: ToolbarsPreset | MarkdownEditorPreset, toolbarName: string) => T;
interface GetToolbarsConfigsArgs {
    toolbarsPreset?: ToolbarsPreset;
    props: Pick<MarkdownEditorViewProps, 'markupToolbarConfig' | 'wysiwygToolbarConfig' | 'wysiwygHiddenActionsConfig' | 'markupHiddenActionsConfig'>;
    preset: MarkdownEditorPreset;
}
export declare const getToolbarsConfigs: ({ toolbarsPreset, props, preset }: GetToolbarsConfigsArgs) => {
    wysiwygToolbarConfig: WToolbarData;
    markupToolbarConfig: MToolbarData;
    wysiwygHiddenActionsConfig: import("../types").WToolbarItemData[];
    markupHiddenActionsConfig: import("../types").MToolbarItemData[];
};
export {};
