"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.wGptItemData = exports.cnGptButton = void 0;
const tslib_1 = require("tslib");
const classname_1 = require("@bem-react/classname");
const extension_1 = require("../../../i18n/gpt/extension");
const GPT_1 = tslib_1.__importDefault(require("../../../icons/GPT"));
const types_1 = require("../../../toolbar/types");
const constants_1 = require("./constants");
exports.cnGptButton = (0, classname_1.cn)('gpt-button');
exports.wGptItemData = {
    type: types_1.ToolbarDataType.SingleButton,
    id: 'gpt',
    title: () => `${(0, extension_1.i18n)('help-with-text')}`,
    hotkey: constants_1.gptHotKeys.openGptKeyTooltip,
    icon: { data: GPT_1.default },
    disabledPopoverVisible: false,
    exec: (actionsStorage) => actionsStorage.actions.addGptWidget.run({}),
    isActive: (actionsStorage) => actionsStorage.actions.addGptWidget.isActive(),
    isEnable: (actionsStorage) => actionsStorage.actions.addGptWidget.isEnable(),
    className: (0, exports.cnGptButton)(),
};
