/**
 * Parses markdown-style markers from the start of a line
 * Returns an array of markers found:
 * - ' ' for indentation
 * - '> ' for blockquotes
 * - '* ' or '- ' for list items
 * - '1. ' for numbered lists
 *
 * Example inputs:
 *   "  * list" -> ['  ', '* ']
 *   "> quoted" -> ['> ']
 *   "    nested" -> ['  ', '  ']
 *   "1. list" -> ['1. ']
 */
export declare function parseMarkers(text: string): string[];
