import React from 'react';
import type { ToasterPublicMethods } from '@gravity-ui/uikit';
import { ClassNameProps } from '../classname';
import type { ToolbarsPreset } from '../modules/toolbars/types';
import type { Editor } from './Editor';
import type { MToolbarData, MToolbarItemData, WToolbarData, WToolbarItemData } from './toolbar/types';
import '../styles/styles.css';
import './MarkdownEditorView.css';
export declare const cnEditorComponent: import("@bem-react/classname").ClassNameFormatter;
export declare type MarkdownEditorViewProps = ClassNameProps & {
    editor?: Editor;
    autofocus?: boolean;
    toolbarsPreset?: ToolbarsPreset;
    /**
     * @deprecated use `toolbarsPreset` instead
     */
    markupToolbarConfig?: MToolbarData;
    /**
     * @deprecated use `toolbarsPreset` instead
     */
    wysiwygToolbarConfig?: WToolbarData;
    /**
     * @deprecated use `toolbarsPreset` instead
     */
    markupHiddenActionsConfig?: MToolbarItemData[];
    /**
     * @deprecated use `toolbarsPreset` instead
     */
    wysiwygHiddenActionsConfig?: WToolbarItemData[];
    /** @default true */
    settingsVisible?: boolean;
    toaster: ToasterPublicMethods;
    stickyToolbar: boolean;
    enableSubmitInPreview?: boolean;
    hidePreviewAfterSubmit?: boolean;
};
export declare const MarkdownEditorView: React.ForwardRefExoticComponent<ClassNameProps & {
    editor?: Editor | undefined;
    autofocus?: boolean | undefined;
    toolbarsPreset?: ToolbarsPreset | undefined;
    /**
     * @deprecated use `toolbarsPreset` instead
     */
    markupToolbarConfig?: MToolbarData | undefined;
    /**
     * @deprecated use `toolbarsPreset` instead
     */
    wysiwygToolbarConfig?: WToolbarData | undefined;
    /**
     * @deprecated use `toolbarsPreset` instead
     */
    markupHiddenActionsConfig?: MToolbarItemData[] | undefined;
    /**
     * @deprecated use `toolbarsPreset` instead
     */
    wysiwygHiddenActionsConfig?: WToolbarItemData[] | undefined;
    /** @default true */
    settingsVisible?: boolean | undefined;
    toaster: ToasterPublicMethods;
    stickyToolbar: boolean;
    enableSubmitInPreview?: boolean | undefined;
    hidePreviewAfterSubmit?: boolean | undefined;
} & React.RefAttributes<HTMLDivElement>>;
