var _ExtensionsManager_schemaRegistry, _ExtensionsManager_parserRegistry, _ExtensionsManager_serializerRegistry, _ExtensionsManager_nodeViewCreators, _ExtensionsManager_markViewCreators, _ExtensionsManager_pmTransformers, _ExtensionsManager_mdForMarkup, _ExtensionsManager_mdForText, _ExtensionsManager_extensions, _ExtensionsManager_builder, _ExtensionsManager_spec, _ExtensionsManager_deps, _ExtensionsManager_plugins, _ExtensionsManager_actions, _ExtensionsManager_nodeViews, _ExtensionsManager_markViews, _ExtensionsManager_serializerDynamicModifier, _ExtensionsManager_parserDynamicModifier;
import { __classPrivateFieldGet, __classPrivateFieldSet } from "tslib";
import MarkdownIt from 'markdown-it';
import { ActionsManager } from './ActionsManager';
import { ExtensionBuilder } from './ExtensionBuilder';
import { ParserTokensRegistry } from './ParserTokensRegistry';
import { SchemaSpecRegistry } from './SchemaSpecRegistry';
import { SerializerTokensRegistry } from './SerializerTokensRegistry';
export class ExtensionsManager {
    constructor({ extensions, options = {} }) {
        var _a, _b, _c, _d, _e, _f, _g;
        _ExtensionsManager_schemaRegistry.set(this, void 0);
        _ExtensionsManager_parserRegistry.set(this, void 0);
        _ExtensionsManager_serializerRegistry.set(this, void 0);
        _ExtensionsManager_nodeViewCreators.set(this, new Map());
        _ExtensionsManager_markViewCreators.set(this, new Map());
        _ExtensionsManager_pmTransformers.set(this, []);
        _ExtensionsManager_mdForMarkup.set(this, void 0);
        _ExtensionsManager_mdForText.set(this, void 0);
        _ExtensionsManager_extensions.set(this, void 0);
        _ExtensionsManager_builder.set(this, void 0);
        _ExtensionsManager_spec.set(this, void 0);
        _ExtensionsManager_deps.set(this, void 0);
        _ExtensionsManager_plugins.set(this, []);
        _ExtensionsManager_actions.set(this, {});
        _ExtensionsManager_nodeViews.set(this, {});
        _ExtensionsManager_markViews.set(this, {});
        _ExtensionsManager_serializerDynamicModifier.set(this, void 0);
        _ExtensionsManager_parserDynamicModifier.set(this, void 0);
        this.processNode = (name, { spec, fromMd, toMd: toMd, view }) => {
            __classPrivateFieldGet(this, _ExtensionsManager_schemaRegistry, "f").addNode(name, spec);
            __classPrivateFieldGet(this, _ExtensionsManager_parserRegistry, "f").addToken(fromMd.tokenName || name, fromMd.tokenSpec);
            __classPrivateFieldGet(this, _ExtensionsManager_serializerRegistry, "f").addNode(name, toMd);
            if (view) {
                __classPrivateFieldGet(this, _ExtensionsManager_nodeViewCreators, "f").set(name, view);
            }
        };
        this.processMark = (name, { spec, fromMd, toMd, view }) => {
            __classPrivateFieldGet(this, _ExtensionsManager_schemaRegistry, "f").addMark(name, spec);
            __classPrivateFieldGet(this, _ExtensionsManager_parserRegistry, "f").addToken(fromMd.tokenName || name, fromMd.tokenSpec);
            __classPrivateFieldGet(this, _ExtensionsManager_serializerRegistry, "f").addMark(name, toMd);
            if (view) {
                __classPrivateFieldGet(this, _ExtensionsManager_markViewCreators, "f").set(name, view);
            }
        };
        __classPrivateFieldSet(this, _ExtensionsManager_schemaRegistry, new SchemaSpecRegistry(undefined, (_a = options.dynamicModifiers) === null || _a === void 0 ? void 0 : _a.schema), "f");
        __classPrivateFieldSet(this, _ExtensionsManager_parserRegistry, new ParserTokensRegistry(), "f");
        __classPrivateFieldSet(this, _ExtensionsManager_serializerRegistry, new SerializerTokensRegistry(), "f");
        if (options.dynamicModifiers) {
            __classPrivateFieldSet(this, _ExtensionsManager_parserDynamicModifier, (_b = options.dynamicModifiers) === null || _b === void 0 ? void 0 : _b.parser, "f");
            __classPrivateFieldSet(this, _ExtensionsManager_serializerDynamicModifier, (_c = options.dynamicModifiers) === null || _c === void 0 ? void 0 : _c.serializer, "f");
        }
        __classPrivateFieldSet(this, _ExtensionsManager_extensions, extensions, "f");
        const mdPreset = (_e = (_d = options.mdOpts) === null || _d === void 0 ? void 0 : _d.preset) !== null && _e !== void 0 ? _e : 'default';
        __classPrivateFieldSet(this, _ExtensionsManager_mdForMarkup, new MarkdownIt(mdPreset, (_f = options.mdOpts) !== null && _f !== void 0 ? _f : {}), "f");
        __classPrivateFieldSet(this, _ExtensionsManager_mdForText, new MarkdownIt(mdPreset, (_g = options.mdOpts) !== null && _g !== void 0 ? _g : {}), "f");
        if (options.linkifyTlds) {
            __classPrivateFieldGet(this, _ExtensionsManager_mdForMarkup, "f").linkify.tlds(options.linkifyTlds, true);
            __classPrivateFieldGet(this, _ExtensionsManager_mdForText, "f").linkify.tlds(options.linkifyTlds, true);
        }
        if (options.pmTransformers) {
            __classPrivateFieldSet(this, _ExtensionsManager_pmTransformers, options.pmTransformers, "f");
        }
        // TODO: add prefilled context
        __classPrivateFieldSet(this, _ExtensionsManager_builder, new ExtensionBuilder(), "f");
    }
    static process(extensions, options) {
        return new this({ extensions, options }).build();
    }
    build() {
        this.processExtensions();
        this.createDeps();
        this.createDerived();
        return Object.assign(Object.assign({}, __classPrivateFieldGet(this, _ExtensionsManager_deps, "f")), { actions: __classPrivateFieldGet(this, _ExtensionsManager_deps, "f").actions, rawActions: __classPrivateFieldGet(this, _ExtensionsManager_actions, "f"), plugins: __classPrivateFieldGet(this, _ExtensionsManager_plugins, "f"), nodeViews: __classPrivateFieldGet(this, _ExtensionsManager_nodeViews, "f"), markViews: __classPrivateFieldGet(this, _ExtensionsManager_markViews, "f") });
    }
    buildDeps() {
        this.processExtensions();
        this.createDeps();
        return __classPrivateFieldGet(this, _ExtensionsManager_deps, "f");
    }
    processExtensions() {
        __classPrivateFieldSet(this, _ExtensionsManager_spec, __classPrivateFieldGet(this, _ExtensionsManager_builder, "f").use(__classPrivateFieldGet(this, _ExtensionsManager_extensions, "f")).build(), "f");
        __classPrivateFieldSet(this, _ExtensionsManager_mdForMarkup, __classPrivateFieldGet(this, _ExtensionsManager_spec, "f").configureMd(__classPrivateFieldGet(this, _ExtensionsManager_mdForMarkup, "f"), 'markup'), "f");
        __classPrivateFieldSet(this, _ExtensionsManager_mdForText, __classPrivateFieldGet(this, _ExtensionsManager_spec, "f").configureMd(__classPrivateFieldGet(this, _ExtensionsManager_mdForText, "f"), 'text'), "f");
        __classPrivateFieldGet(this, _ExtensionsManager_spec, "f").nodes().forEach(this.processNode);
        __classPrivateFieldGet(this, _ExtensionsManager_spec, "f").marks().forEach(this.processMark);
    }
    createParser(schema, mdInstance) {
        return __classPrivateFieldGet(this, _ExtensionsManager_parserRegistry, "f").createParser(schema, mdInstance, __classPrivateFieldGet(this, _ExtensionsManager_pmTransformers, "f"), __classPrivateFieldGet(this, _ExtensionsManager_parserDynamicModifier, "f"));
    }
    createDeps() {
        const actions = new ActionsManager();
        const schema = __classPrivateFieldGet(this, _ExtensionsManager_schemaRegistry, "f").createSchema();
        const markupParser = this.createParser(schema, __classPrivateFieldGet(this, _ExtensionsManager_mdForMarkup, "f"));
        const textParser = this.createParser(schema, __classPrivateFieldGet(this, _ExtensionsManager_mdForText, "f"));
        const serializer = __classPrivateFieldGet(this, _ExtensionsManager_serializerRegistry, "f").createSerializer(__classPrivateFieldGet(this, _ExtensionsManager_serializerDynamicModifier, "f"));
        __classPrivateFieldSet(this, _ExtensionsManager_deps, {
            schema,
            actions,
            markupParser,
            textParser,
            serializer,
        }, "f");
    }
    createDerived() {
        __classPrivateFieldSet(this, _ExtensionsManager_plugins, __classPrivateFieldGet(this, _ExtensionsManager_spec, "f").plugins(__classPrivateFieldGet(this, _ExtensionsManager_deps, "f")), "f");
        Object.assign(__classPrivateFieldGet(this, _ExtensionsManager_actions, "f"), __classPrivateFieldGet(this, _ExtensionsManager_spec, "f").actions(__classPrivateFieldGet(this, _ExtensionsManager_deps, "f")));
        for (const [name, view] of __classPrivateFieldGet(this, _ExtensionsManager_nodeViewCreators, "f")) {
            __classPrivateFieldGet(this, _ExtensionsManager_nodeViews, "f")[name] = view(__classPrivateFieldGet(this, _ExtensionsManager_deps, "f"));
        }
        for (const [name, view] of __classPrivateFieldGet(this, _ExtensionsManager_markViewCreators, "f")) {
            __classPrivateFieldGet(this, _ExtensionsManager_markViews, "f")[name] = view(__classPrivateFieldGet(this, _ExtensionsManager_deps, "f"));
        }
    }
}
_ExtensionsManager_schemaRegistry = new WeakMap(), _ExtensionsManager_parserRegistry = new WeakMap(), _ExtensionsManager_serializerRegistry = new WeakMap(), _ExtensionsManager_nodeViewCreators = new WeakMap(), _ExtensionsManager_markViewCreators = new WeakMap(), _ExtensionsManager_pmTransformers = new WeakMap(), _ExtensionsManager_mdForMarkup = new WeakMap(), _ExtensionsManager_mdForText = new WeakMap(), _ExtensionsManager_extensions = new WeakMap(), _ExtensionsManager_builder = new WeakMap(), _ExtensionsManager_spec = new WeakMap(), _ExtensionsManager_deps = new WeakMap(), _ExtensionsManager_plugins = new WeakMap(), _ExtensionsManager_actions = new WeakMap(), _ExtensionsManager_nodeViews = new WeakMap(), _ExtensionsManager_markViews = new WeakMap(), _ExtensionsManager_serializerDynamicModifier = new WeakMap(), _ExtensionsManager_parserDynamicModifier = new WeakMap();
