export function convertDynamicModifiersConfigs(modifiers) {
    const parser = {};
    const schema = {};
    const serializer = {};
    modifiers.forEach((modifier) => {
        var _a, _b, _c, _d;
        switch (modifier.type) {
            case 'parserToken': {
                const { tokenName, process } = modifier;
                parser[tokenName] = parser[tokenName] || {};
                parser[tokenName].processToken = parser[tokenName].processToken || [];
                (_a = parser[tokenName].processToken) === null || _a === void 0 ? void 0 : _a.push(process);
                break;
            }
            case 'parserNodeAttrs': {
                const { tokenName, process } = modifier;
                parser[tokenName] = parser[tokenName] || {};
                parser[tokenName].processNodeAttrs = parser[tokenName].processNodeAttrs || [];
                (_b = parser[tokenName].processNodeAttrs) === null || _b === void 0 ? void 0 : _b.push(process);
                break;
            }
            case 'parserNode': {
                const { nodeName, process } = modifier;
                parser[nodeName] = parser[nodeName] || {};
                parser[nodeName].processNode = parser[nodeName].processNode || [];
                (_c = parser[nodeName].processNode) === null || _c === void 0 ? void 0 : _c.push(process);
                break;
            }
            case 'serializerNode': {
                const { nodeName, process } = modifier;
                serializer[nodeName] = serializer[nodeName] || {};
                serializer[nodeName].processNode = serializer[nodeName].processNode || [];
                (_d = serializer[nodeName].processNode) === null || _d === void 0 ? void 0 : _d.push(process);
                break;
            }
            case 'schemaNodeSpec': {
                const { nodeName, allowedAttrs } = modifier;
                schema[nodeName] = { allowedAttrs };
                break;
            }
        }
    });
    return { parser, schema, serializer };
}
