import { snippet } from '@codemirror/autocomplete';
import { i18n } from '../../../i18n/empty-row';
export const emptyRowSnippetTemplate = '&nbsp;\n\n';
export const emptyRowSnippet = snippet(emptyRowSnippetTemplate);
export const emptyRowAutocomplete = {
    autocomplete: (context) => {
        const word = context.matchBefore(/^.*/);
        if (word === null || word === void 0 ? void 0 : word.text.startsWith('&')) {
            return {
                from: word.from,
                options: [
                    {
                        label: '&nbsp;',
                        displayLabel: i18n('snippet.text'),
                        type: 'text',
                        apply: emptyRowSnippet,
                    },
                ],
            };
        }
        return null;
    },
};
