import React from 'react';
import type { SearchQuery } from '@codemirror/search';
import './SearchPopup.css';
declare type SearchInitial = Pick<SearchQuery, 'search' | 'caseSensitive' | 'wholeWord'>;
declare type SearchConfig = Pick<SearchInitial, 'caseSensitive' | 'wholeWord'>;
interface SearchCardProps {
    initial: SearchInitial;
    onSearchKeyDown?: (query: string) => void;
    onChange?: (query: string) => void;
    onClose?: (query: string) => void;
    onSearchPrev?: (query: string) => void;
    onSearchNext?: (query: string) => void;
    onConfigChange?: (config: SearchConfig) => void;
}
export declare const SearchCard: React.FC<SearchCardProps>;
export interface SearchPopupProps extends SearchCardProps {
    open: boolean;
    anchor: HTMLElement;
    onClose: () => void;
}
export declare const SearchPopup: React.FC<SearchPopupProps>;
interface SearchPopupWithRefProps extends Omit<SearchPopupProps, 'anchor'> {
    anchor: HTMLElement | null;
}
export declare function renderSearchPopup({ anchor, open, onClose, ...props }: SearchPopupWithRefProps): JSX.Element;
export {};
